/// <reference types="pouchdb-core" />
/// <reference types="websql" />
/// <reference types="pouchdb-adapter-idb" />
/// <reference types="pouchdb-adapter-websql" />
/// <reference types="pouchdb-node" />
export declare type PouchDocument = PouchDB.Core.Document<any> & PouchDB.Core.GetMeta;
export declare type PouchAllDocs = PouchDB.Core.AllDocsWithKeyOptions & PouchDB.Core.AllDocsWithKeysOptions & PouchDB.Core.AllDocsWithinRangeOptions & PouchDB.Core.AllDocsOptions;
export interface SQLPouchAdapter {
    _id: Promise<string>;
    _db: Database;
    _name: string;
    _remote: boolean;
    auto_compaction: boolean;
    type(): string;
    _close(callback: any): void;
    _info(callback: (error: any, info?: Partial<PouchDB.Core.DatabaseInfo>) => void): void;
    _getLocal(id: PouchDB.Core.DocumentId, callback: any): void;
    _putLocal(doc: PouchDocument, callback: any): void;
    _putLocal(doc: PouchDocument, opts: Partial<{
        ctx: SQLTransaction;
    }>, callback: any): void;
    _removeLocal(doc: PouchDocument, opts: Partial<{
        ctx: SQLTransaction;
    }>, callback: any): void;
    _destroy(opts: any, callback: any): void;
    _changes(opts: any): {
        cancel(): void;
    };
    _allDocs(opts: PouchAllDocs, callback: any): void;
    _bulkDocs(req: any, reqOpts: any, callback: any): void;
    _get(docId: PouchDB.Core.DocumentId, assign: any, callback: any): void;
    _getRevisionTree(docId: PouchDB.Core.DocumentId, callback: any): void;
    _doCompaction(docId: PouchDB.Core.DocumentId, revs: string[], callback: any): any;
    _getAttachment(_id: PouchDB.Core.DocumentId, att: PouchDB.Core.AttachmentId, attObj: PouchDB.Core.Attachment, attOpts: {
        ctx: SQLTransaction;
        binary: boolean;
    }, cb: PouchDB.Core.Callback<Blob | Buffer>): void;
}
declare function WebSqlPouch(opts: PouchDB.Configuration.DatabaseConfiguration, cb: {
    (_: null, api: any): void;
    (error: any): void;
}): void;
export default WebSqlPouch;
