"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function decodeUtf8(str) {
    return decodeURIComponent(escape(str));
}
function hexToInt(charCode) {
    return charCode < 65 ? charCode - 48 : charCode - 55;
}
function parseHexUtf8(str, start, end) {
    let result = '';
    while (start < end) {
        result += String.fromCharCode((hexToInt(str.charCodeAt(start++)) << 4) | hexToInt(str.charCodeAt(start++)));
    }
    return result;
}
function parseHexUtf16(str, start, end) {
    let result = '';
    while (start < end) {
        result += String.fromCharCode((hexToInt(str.charCodeAt(start + 2)) << 12) |
            (hexToInt(str.charCodeAt(start + 3)) << 8) |
            (hexToInt(str.charCodeAt(start)) << 4) |
            hexToInt(str.charCodeAt(start + 1)));
        start += 4;
    }
    return result;
}
function parseHexString(str, encoding) {
    if (encoding === 'UTF-8') {
        return decodeUtf8(parseHexUtf8(str, 0, str.length));
    }
    else {
        return parseHexUtf16(str, 0, str.length);
    }
}
exports.default = parseHexString;
//# sourceMappingURL=parseHex.js.map